<?php

// ----- Récupération de la base de données stockée dans le fichier users.json
$jsonString = file_get_contents('users.json');
$users = json_decode($jsonString, true);

// ----- Ajout de l'en-tête pour l'envoi des données au format JSON
header('Content-Type: application/json');

// ----- Récupération des paramètres de l'URL
$get_function = $_GET['function'] ?? '';
$get_user = $_GET['user'] ?? '';

// ----- Contrôleur

// Exemples d'appels :
// - Restaurer la base de données à partir du fichier users.orig.json (GET) :
//   users.php?function=restore
// - Envoyer tous les users (GET) :
//   users.php?function=readall
// - Envoyer le user dont l'id a la valeur 1 (GET) :
//   users.php?function=read&user=1
// - Recevoir un nouveau user et envoyer le tableau users mis à jour (POST) :
//   users.php?function=create
// - Supprimer le user dont l'id a la valeur 1 et envoyer le tableau users mis à jour (DELETE) :
//   users.php?function=delete&user=1
// - Mettre à jour le user dont l'id a la valeur 1 et envoyer le tableau users mis à jour (PUT) :
//   users.php?function=update&user=1

switch ($_SERVER['REQUEST_METHOD']) {
   case "GET":
      if ($get_function == "readall") {
         echo json_encode($users);
      } elseif ($get_function == "read" && $get_user != '') {
         $data = null;
         $found = false;
         foreach ($users as &$user)
            if ($user["id"] == $get_user) {
               $data = $user;
               $found = true;
               break;
            }
         if ($found) {
            echo json_encode($data);
         }
      } elseif ($get_function == "restore") {
         $newJsonString = file_get_contents('users.orig.json');
         file_put_contents('users.json', $newJsonString);
         echo $newJsonString;
      }
      break;
   case "POST":
      if ($get_function == "create") {
         $user = json_decode(file_get_contents('php://input'), true);
         if ($user <> null) {
            array_push($users, $user);
            $newJsonString = json_encode($users);
            file_put_contents('users.json', $newJsonString);
            echo json_encode($users);
         }
      }
      break;
   case "PUT":
      if ($get_function == "update" && $get_user != '') {
         $data = json_decode(file_get_contents('php://input'), true);
         if ($data <> null) {
            $found = false;
            $index = 0;
            foreach ($users as &$user) {
               if ($user["id"] == $get_user) {
                  $found = true;
                  break;
               }
               $index++;
            }
            if ($found) {
               foreach ($data as $key => $value) {
                  $users[$index][$key] = $value;
               }
               $newJsonString = json_encode($users);
               file_put_contents('users.json', $newJsonString);
               echo json_encode($users);
            }
         }
      }
      break;
   case "DELETE":
      if ($get_function == "delete" && $get_user != '') {
         $found = false;
         $index = 0;
         foreach ($users as &$user) {
            if ($user["id"] == $get_user) {
               $found = true;
               break;
            }
            $index++;
         }
         if ($found) {
            array_splice($users, $index, 1);
            $newJsonString = json_encode($users);
            file_put_contents('users.json', $newJsonString);
            echo json_encode($users);
         }
      }
      break;
   default:
      break;
}
